Ensure that grub-pc/install_devices is pointing to the requested device
[grml-debootstrap.git] / chroot-script
index ce3f624..978eea3 100755 (executable)
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/bash
 # Filename:      /etc/debootstrap/chroot-script
 # Purpose:       script executed in chroot when installing Debian via grml-debootstrap
 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
@@ -9,6 +9,14 @@
 # this script as /bin/chroot-script on your new installed system
 ################################################################################
 
+# error_handler {{{
+if [ "$REPORT_TRAP_ERR" = "yes" ] || [ "$FAIL_TRAP_ERR" = "yes" ]; then
+   set -E
+   set -o pipefail
+   trap "error_handler" ERR
+fi
+# }}}
+
 . /etc/debootstrap/config    || exit 1
 . /etc/debootstrap/variables || exit 1
 
@@ -28,9 +36,9 @@ if [ -x /usr/bin/aptitude ] ; then
       APTUPGRADE="aptitude -y safe-upgrade $DPKG_OPTIONS"
    fi
 else
-   APTINSTALL="apt-get --force-yes -y --no-install-recommends install $DPKG_OPTIONS"
+   APTINSTALL="apt-get -y --no-install-recommends install $DPKG_OPTIONS"
    APTUPDATE="apt-get update $DPKG_OPTIONS"
-   APTUPGRADE="apt-get --force-yes -y upgrade $DPKG_OPTIONS"
+   APTUPGRADE="apt-get -y upgrade $DPKG_OPTIONS"
 fi
 
 if [ -z "$STAGES" ] ; then
@@ -44,7 +52,7 @@ stage() {
   if [ -n "$2" ] ; then
      echo "$2" > "$STAGES/$1"
      return 0
-  elif grep -q done "$STAGES/$1" 2>/dev/null ; then
+  elif grep -q 'done' "$STAGES/$1" 2>/dev/null ; then
      echo "   [*] Notice: stage $1 has been executed already, skipping execution therefore.">&2
      return 1
   fi
@@ -70,15 +78,18 @@ chrootmirror() {
   fi
 
   if [ -z "$COMPONENTS" ] ; then
-    COMPONENTS='main contrib non-free'
+    COMPONENTS='main'
   fi
   echo "Using repository components $COMPONENTS"
 
   if [ -n "$ISO" ] ; then
     echo "Adjusting sources.list for ISO (${ISO})."
     echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
-    echo "Adding mirror entry (${MIRROR}) to sources.list."
-    [ -n "$MIRROR" ] && echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list || true
+
+    if [ -n "$MIRROR" ] ; then
+      echo "Adding mirror entry (${MIRROR}) to sources.list."
+      echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list
+    fi
   else
     if [ -n "$MIRROR" ] ; then
       echo "Adjusting sources.list for mirror (${MIRROR})."
@@ -86,9 +97,19 @@ chrootmirror() {
     fi
   fi
 
+  # LTS support
+  case "$RELEASE" in
+    squeeze)
+      if [ -n "$MIRROR" ] ; then
+        echo "Release matching $RELEASE - enabling LTS support in sources.list"
+        echo "deb $MIRROR ${RELEASE}-lts $COMPONENTS" >> /etc/apt/sources.list
+      fi
+      ;;
+  esac
+
   # add security.debian.org:
   case "$RELEASE" in
-    unstable|sid) ;;  # no security pool available
+    unstable|sid|lenny) ;;  # no security pool available
     *)
       echo "Adding security.debian.org to sources.list."
       echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
@@ -109,7 +130,7 @@ remove_chrootmirror() {
     TMP_ISO=$(echo "$ISO" |sed 's#/#\\/#g')
     sed -i "/deb $TMP_ISO $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
   else
-    if [ -n "$MIRROR" -a -n "$(echo $MIRROR|grep file:)" ] ; then
+    if [ -n "$MIRROR" ] && echo "$MIRROR" | grep -q 'file:' ; then
       echo "Removing local mirror (${MIRROR}) from sources.list."
       TMP_MIRROR=$(echo "$MIRROR" |sed 's#/#\\/#g')
       sed -i "/deb $TMP_MIRROR $RELEASE $COMPONENTS/ D" /etc/apt/sources.list
@@ -141,8 +162,8 @@ EOF
        apt-get update $DPKG_OPTIONS
      else
        # make sure we have the keys available for aptitude
-       gpg --keyserver subkeys.pgp.net --recv-keys F61E2E7CECDEA787
-       gpg --export F61E2E7CECDEA787 | apt-key add - || true # not yet sure
+       gpg --keyserver subkeys.pgp.net --recv-keys 709BCE51568573EBC160E590F61E2E7CECDEA787
+       gpg --export 709BCE51568573EBC160E590F61E2E7CECDEA787 | apt-key add - || true # not yet sure
        # why it's necessary, sometimes we get an error even though it works [mika]
      fi
 
@@ -167,14 +188,14 @@ EOF
 
 # check available backports release version {{{
 checkbackports() {
-  wget -q -O/dev/null http://backports.debian.org/debian-backports/dists/${1}-backports/Release
+  wget -q -O/dev/null "http://backports.debian.org/debian-backports/dists/${1}-backports/Release"
 }
 # }}}
 
 # feature to provide Debian backports repos {{{
 backportrepos() {
     if [ -n "$BACKPORTREPOS" ] ; then
-        if ! checkbackports $RELEASE ; then
+        if ! checkbackports "$RELEASE" ; then
             echo "Backports for ${RELEASE} are not available." >&2
             exit 1
         else
@@ -247,7 +268,7 @@ packages() {
   # as seen to prevent debconf from asking the question interactively.
   [ -f /etc/debootstrap/debconf-selections ] && {
     echo "Preseeding the debconf database, some lines might be skipped..."
-    cat /etc/debootstrap/debconf-selections | debconf-set-selections
+    debconf-set-selections < /etc/debootstrap/debconf-selections
   }
 
   if [ "$PACKAGES" = 'yes' ] ; then
@@ -291,9 +312,19 @@ get_kernel_version() {
     return 0
   fi
 
-  case $ARCH in
-    i386)   KARCH=686   ;;
-    amd64)  KARCH=amd64 ;;
+  local KARCH
+
+  case "$ARCH" in
+    i386)
+      case "$RELEASE" in
+        lenny|squeeze|wheezy) KARCH='686' ;;
+        # since jessie the linux-image-686 image doesn't exist any longer
+        *) KARCH='686-pae' ;;
+      esac
+      ;;
+    amd64)
+      KARCH='amd64'
+      ;;
     *)
       echo "Only i386 and amd64 are currently supported" >&2
       return 1
@@ -320,7 +351,11 @@ kernel() {
   KVER=$(get_kernel_version)
   if [ -n "$KVER" ] ; then
      # note: install busybox to be able to debug initramfs
-     KERNELPACKAGES="linux-image-$KVER linux-headers-$KVER busybox firmware-linux-free firmware-linux"
+     KERNELPACKAGES="linux-image-$KVER linux-headers-$KVER busybox firmware-linux-free"
+     # only add firmware-linux if we have non-free as a component
+     if expr "$COMPONENTS" : '.*non-free' >/dev/null ; then
+       KERNELPACKAGES="$KERNELPACKAGES firmware-linux"
+     fi
      DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL $KERNELPACKAGES
   else
      echo "Warning: Could not find a kernel for your system. Your system won't be able to boot itself!"
@@ -365,12 +400,12 @@ passwords()
     b='2'
      echo "Setting password for user root:"
      while [ "$a" != "$b" ] ; do
-       echo -n "Enter new UNIX password for user root: "
+       printf "Enter new UNIX password for user root: "
        askpass
        a="$resp"
        unset resp
        echo
-       echo -n "Retype new UNIX password for user root: "
+       printf "Retype new UNIX password for user root: "
        askpass
        b="$resp"
        unset resp
@@ -414,25 +449,6 @@ EOF
 }
 # }}}
 
-# set up /etc/network/interfaces {{{
-interfaces() {
-  if ! [ -r /etc/network/interfaces ] || ! grep -q "auto lo" /etc/network/interfaces ; then
-     echo "Setting up /etc/network/interfaces"
-     cat >> /etc/network/interfaces << EOF
-
-# loopback device:
-iface lo inet loopback
-auto lo
-
-# eth0:
-# iface eth0 inet dhcp
-# auto eth0
-
-EOF
-  fi
-}
-# }}}
-
 # set default locales {{{
 default_locales() {
   if [ -n "$DEFAULT_LOCALES" ] ; then
@@ -442,7 +458,7 @@ default_locales() {
       return 0
     fi
 
-    /usr/sbin/update-locale LANG="$DEFAULT_LOCALES"
+    /usr/sbin/update-locale LANGUAGE="$DEFAULT_LANGUAGE" LANG="$DEFAULT_LOCALES"
   fi
 }
 # }}}
@@ -451,7 +467,7 @@ default_locales() {
 timezone() {
   if [ -n "$TIMEZONE" ] ; then
      echo "Adjusting /etc/localtime"
-     ln -sf /usr/share/zoneinfo/$TIMEZONE /etc/localtime
+     ln -sf "/usr/share/zoneinfo/$TIMEZONE" /etc/localtime
   fi
 }
 # }}}
@@ -508,6 +524,20 @@ hostname() {
         sed -i "s/^inet_interfaces = .*/inet_interfaces = loopback-only/" /etc/postfix/main.cf
         grep -q inet_interfaces /etc/postfix/main.cf || echo 'inet_interfaces = loopback-only' >> /etc/postfix/main.cf
      fi
+     if [ -r /etc/mailname ] ; then
+        # adjust /etc/mailname
+        local etc_mail_domain=$(/bin/dnsdomainname 2>/dev/null || echo localdomain)
+        case "$HOSTNAME" in
+          *.*)
+            local mailname="$HOSTNAME"
+            ;;
+          *)
+            local mailname="${HOSTNAME}.${etc_mail_domain}"
+            ;;
+        esac
+        echo "Setting mailname to ${mailname}"
+        echo "$mailname" > /etc/mailname
+     fi
   fi
 }
 # }}}
@@ -526,7 +556,7 @@ initrd() {
   # generate initrd
   if [ -n "$INITRD" ] ; then
      echo "Generating initrd."
-     update-initramfs -c -t -k $KERNELVER
+     update-initramfs -c -t -k "$KERNELVER"
   fi
 }
 # }}}
@@ -539,6 +569,11 @@ grub_install() {
     return 0
   fi
 
+  # make sure this is pre-defined so we have sane settings for automated
+  # upgrades, see https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=711019
+  echo "Setting grub-pc debconf configuration for install device to $GRUB"
+  echo "grub-pc grub-pc/install_devices multiselect $GRUB" | debconf-set-selections
+
   if ! dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
     echo "Notice: grub option set but no grub-pc package, installing it therefore."
     DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL grub-pc
@@ -555,9 +590,20 @@ grub_install() {
         echo "Installing grub on ${GRUB}:"
         grub-install --no-floppy "$GRUB"
      done
+     rm -f /boot/grub/device.map
   else
      echo "Installing grub on ${GRUB}:"
-     grub-install --no-floppy "$GRUB"
+     case "$RELEASE" in
+       lenny|squeeze|wheezy)
+         grub-install --no-floppy "$(readlink -f "${GRUB}")"
+         rm -f /boot/grub/device.map
+         ;;
+       *)
+         echo "(hd0) ${GRUB}" > /boot/grub/device.map
+         grub-install "(hd0)"
+         rm /boot/grub/device.map
+         ;;
+     esac
   fi
 
   echo "Adjusting grub configuration for use on ${GRUB}."
@@ -626,12 +672,12 @@ trap signal_handler HUP INT QUIT TERM
  install_policy_rcd
 
  for i in chrootmirror grmlrepos backportrepos kernelimg_conf \
-     kernel packages extrapackages  reconfigure hosts interfaces \
+     kernel packages extrapackages reconfigure hosts \
      default_locales timezone fstab hostname initrd grub_install passwords \
      custom_scripts upgrade_system remove_apt_cache services \
      remove_chrootmirror; do
      if stage $i ; then
-       $i && stage $i done || exit 1
+       $i && stage $i 'done' || exit 1
      fi
   done
   # always execute the finalize stage: